## mingw-w64-siesta-5.4.1-3.src.tar.zst

=== Util/CMakeLists.txt ===
# Utilities
if( SIESTA_TESTS )
  enable_testing()
endif()

add_subdirectory("TS/TBtrans")
add_subdirectory("TS/PHtrans")
add_subdirectory("TS/tscontour")
add_subdirectory("TS/ts2ts")
add_subdirectory("Contour")
add_subdirectory("Contrib/APostnikov")
add_subdirectory("Gen-basis")
add_subdirectory("Eig2DOS")
add_subdirectory("COOP")
add_subdirectory("Vibra/Src")
add_subdirectory("Denchar/Src")
add_subdirectory("DensityMatrix")
add_subdirectory("Bands")
add_subdirectory("Grid")
add_subdirectory("Grimme")
add_subdirectory("Helpers")
add_subdirectory("HSX")
add_subdirectory("JobList/Src")
add_subdirectory("WFS")
add_subdirectory("VCA")
add_subdirectory("Lindhard")
add_subdirectory("Macroave/Src")
add_subdirectory("ON")
add_subdirectory("Optical")
add_subdirectory("Optimizer")
add_subdirectory("PEXSI")
add_subdirectory("Projections")
add_subdirectory("pdosxml")
add_subdirectory("libsiestaqmmm")
add_subdirectory("QMMM-driver")
add_subdirectory("SpPivot")
add_subdirectory("Unfolding/Src")
add_subdirectory("STM/ol-stm/Src")
add_subdirectory("STM/simple-stm")
add_subdirectory("Sockets")
add_subdirectory("SiestaSubroutine")
add_subdirectory("sies2arc")

=== Tests/16.TranSiesta/CMakeLists.txt ===
siesta_subtest(ts_n_terminal_elec_x LABELS simple
  FIXTURES_SETUP ts_elec_chain_x
  # Return values
  TEST_WORKING_DIRECTORY elec_chain_x_WDIR
)
siesta_subtest(ts_n_terminal_elec_z LABELS simple
  FIXTURES_SETUP ts_elec_chain_z
  # Return values
  TEST_WORKING_DIRECTORY elec_chain_z_WDIR
)


if( SIESTA_WITH_NCDF )

  # TranSiesta run + TBtrans for n_terminal_3
  siesta_subtest(ts_n_terminal_3
    FILES_SETUP
      "${elec_chain_x_WDIR}/ts_n_terminal_elec_x.TSHS"
      "${elec_chain_z_WDIR}/ts_n_terminal_elec_z.nc"
    FIXTURES_SETUP ts_n_terminal_3
    FIXTURES_REQUIRED ts_elec_chain_x ts_elec_chain_z
    # Return values
    TEST_WORKING_DIRECTORY n_terminal_3_WDIR
    FILES_CLEANUP ts_n_terminal_3.TSDE ts_n_terminal_3.TSGFel-1 ts_n_terminal_3.TSGFel-3 ts_n_terminal_3.TSGFel-4
  )
  siesta_subtest(ts_n_terminal_3 NAME_ALTER ts_n_terminal_3_tbt
    EXEC ${PROJECT_NAME}.tbtrans
    FILES_SETUP
      "${elec_chain_x_WDIR}/ts_n_terminal_elec_x.TSHS"
      "${elec_chain_z_WDIR}/ts_n_terminal_elec_z.nc"
      # Explicitly test the full reading of TSHS file
      "${n_terminal_3_WDIR}/ts_n_terminal_3.TSHS"
    # This requires the TS test to have runned, but the FIXTURE there depends on another
    FIXTURES_REQUIRED ts_n_terminal_3
    FILES_CLEANUP ts_n_terminal_3.TBT.nc
  )

endif()

# TranSiesta run + TBtrans for ts_chain
siesta_subtest(ts_chain
  FILES_SETUP
    "${elec_chain_x_WDIR}/ts_n_terminal_elec_x.HSX"
  FIXTURES_SETUP ts_chain
  FIXTURES_REQUIRED ts_elec_chain_x
  TEST_WORKING_DIRECTORY chain_WDIR
  FILES_CLEANUP ts_chain.TSDE ts_chain.TSGFhigh ts_chain.TSGFlow
)
siesta_subtest(ts_chain NAME_ALTER ts_chain_tbt
  EXEC ${PROJECT_NAME}.tbtrans
  FILES_SETUP
    "${elec_chain_x_WDIR}/ts_n_terminal_elec_x.HSX"
    "${chain_WDIR}/ts_chain.TS.HSX"
  # This requires the TS test to have runned, but the FIXTURE there depends on another
  FIXTURES_REQUIRED ts_chain
  FILES_CLEANUP ts_chain.TBT.nc
)

=== Util/MPI_test/CMakeLists.txt ===
#
# This function uses 'SIESTA_TESTS_MPI_NUMPROCS' as set in a previous
# call to TestMPIConfig.
#

# Note TARGET_FILE idiom for generality. This also covers the case in
# which the current directory is not in the PATH ('./prog' could work
# too). Otherwise mpiexec would not find it.

function(setup_test_mpi prog)

   set(mpiexec_args
          ${MPIEXEC_NUMPROC_FLAG} ${SIESTA_TESTS_MPI_NUMPROCS}
          ${MPIEXEC_PREFLAGS}
          $<TARGET_FILE:${prog}>
          ${MPIEXEC_POSTFLAGS})

   add_test( NAME    ${prog}_mpi_np_${SIESTA_TESTS_MPI_NUMPROCS}
             COMMAND ${MPIEXEC_EXECUTABLE} ${mpiexec_args} )

endfunction()

siesta_add_executable(${PROJECT_NAME}.pi3
  pi3.F
  )

target_link_libraries(${PROJECT_NAME}.pi3
  PRIVATE
    ${PROJECT_NAME}.mpi
    ${PROJECT_NAME}.mpi_macros
)
#
# To check "singleton" MPI runs (i.e., that we can run
# a parallel program without 'mpirun'). This is not
# possible in some systems (e.g. IBM's MPI)
#
add_test(NAME pi3_Runs_Singleton COMMAND ${PROJECT_NAME}.pi3)

# Normal MPI run with ${SIESTA_TESTS_MPI_NUMPROCS}
setup_test_mpi(${PROJECT_NAME}.pi3)


siesta_add_executable(${PROJECT_NAME}.newcomm
  newcomm.F
  ${PROJECT_SOURCE_DIR}/Src/MPI
)

target_link_libraries(${PROJECT_NAME}.newcomm
  PRIVATE
    ${PROJECT_NAME}.mpi
    ${PROJECT_NAME}.mpi_macros
  )
setup_test_mpi(${PROJECT_NAME}.newcomm)

#
siesta_add_executable(${PROJECT_NAME}.blacs_prb blacs_prb.f90 )
target_link_libraries(${PROJECT_NAME}.blacs_prb
  PRIVATE
  SCALAPACK::SCALAPACK
  MPI::MPI_Fortran
  LAPACK::LAPACK
)
setup_test_mpi(${PROJECT_NAME}.blacs_prb)


siesta_add_executable(${PROJECT_NAME}.pblas_prb  pblas_prb.f90 )
target_link_libraries(${PROJECT_NAME}.pblas_prb
  PRIVATE
  SCALAPACK::SCALAPACK
  MPI::MPI_Fortran
  LAPACK::LAPACK
)

file(COPY "${CMAKE_CURRENT_LIST_DIR}/pblas.dat" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")

#
# Run the test automatically only if we have enough ranks available.
#
if("${SIESTA_TESTS_MPI_NUMPROCS}" GREATER_EQUAL 4)
  setup_test_mpi(${PROJECT_NAME}.pblas_prb)
endif()

=== Util/QMMM-driver/CMakeLists.txt ===
add_subdirectory("Src")

if( SIESTA_TESTS )
 add_subdirectory("Tests")
endif()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=siesta
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.4.1
pkgrel=3
pkgdesc="A first-principles materials simulation code using DFT. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://siesta-project.org/siesta'
msys2_repository_url="https://gitlab.com/siesta-project/siesta"
msys2_references=(
  'aur: siesta'
)
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-fftw"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-s-dftd3")
         "${MINGW_PACKAGE_PREFIX}-libfdf"
         "${MINGW_PACKAGE_PREFIX}-libgridxc"
         "${MINGW_PACKAGE_PREFIX}-libpsml"
         #"${MINGW_PACKAGE_PREFIX}-libxc"
         "${MINGW_PACKAGE_PREFIX}-mctc-lib"
         "${MINGW_PACKAGE_PREFIX}-netcdf-fortran"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-omp")
         "${MINGW_PACKAGE_PREFIX}-openblas"
         #$([[ ${CARCH} == aarch64 ]] || echo "${MINGW_PACKAGE_PREFIX}-scalapack")
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-scalapack")
         "${MINGW_PACKAGE_PREFIX}-xmlf90")
makedepends=("${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             #$([[ ${CARCH} == aarch64 ]] || echo "${MINGW_PACKAGE_PREFIX}-msmpi")
             $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-msmpi")
             "${MINGW_PACKAGE_PREFIX}-python")
_w90_ver=3.1.0
source=("https://gitlab.com/siesta-project/siesta/-/releases/${pkgver}/downloads/${_realname}-${pkgver}.tar.gz"
        "https://github.com/wannier-developers/wannier90/archive/v${_w90_ver}/wannier90-${_w90_ver}.tar.gz"
        "001-fix-build-on-mingw.patch")
sha256sums=('531ed2fa021d6a733739b5c1ba7d8cf32fe5aee3df6774a8e748ba3d6faaebcc'
            '40651a9832eb93dec20a8360dd535262c261c34e13c41b6755fa6915c936b254'
            '6c5c587e1b66b94391e090688edc36daca9033360113148df4a5c43b8f619752')
noextract=("wannier90-${_w90_ver}.tar.gz")

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  patch -Np1 -i "${srcdir}"/001-fix-build-on-mingw.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  local _fflags=""
  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    _fflags+=" -fallow-invalid-boz"
    _extra_config+=("-DSIESTA_WITH_MPI=ON" "-DSIESTA_WITH_OPENMP=ON" "-DSIESTA_WITH_DFTD3=ON")
  else
    _extra_config+=("-DSIESTA_WITH_MPI=OFF" "-DSIESTA_WITH_OPENMP=OFF" "-DSIESTA_WITH_DFTD3=OFF")
  fi

  if [[ ${CARCH} == x86_64 ]]; then
    _fflags+=" -march=x86-64-v3"
    CFLAGS+=" -march=x86-64-v3"
  fi

  FFLAGS="${_fflags}" \
  WANNIER90_PACKAGE="${srcdir}"/wannier90-${_w90_ver}.tar.gz \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DSIESTA_SHARED_LIBS=ON \
      -DSIESTA_WITH_ELPA=OFF \
      -DSIESTA_WITH_ELSI=OFF \
      -DSIESTA_WITH_FLOOK=OFF \
      -DSIESTA_WITH_IPO=OFF \
      -DSIESTA_SET_RPATH=OFF \
      -DSIESTA_WITH_FFTW=ON \
      -DSIESTA_WITH_LIBXC=ON \
      -DSIESTA_WITH_NETCDF=ON \
      -DSIESTA_WITH_WANNIER90=ON \
      -DSIESTA_TESTS=OFF \
      -DBLA_VENDOR=OpenBLAS \
      -DSCALAPACK_LIBRARY=${MINGW_PREFIX}/lib/libscalapack.dll.a \
      -DFortran_FLAGS_RELEASE="-O3" \
      -DC_FLAGS_RELEASE="-O3" \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"
}
